;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Effect Name : Feedback - part1
;
; Description : Getting value from the feedback path and adding it
;
; Nb In       :	1
; Nb Out      : 1
;
; Input       : 1 channel signal
; Output      : 1 channel signal
;
; Cycles      : 4 + 8 cycles (-1=unknownw)
; Memory      : 2 words (without init)
; Delay Line  :	no
;
; Author      : Lall
; Date        : 02/03/2003
; Version     : 1.0
;
; Control parameters (see SEC1): 
;	none
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;; SEC0 General Parameters
ABS	INIT		0x3ff		; init params at first run

	;; SEC1 Control Parameters
ABS	Feedback	0x001

	;; SEC2 Initial values of control parameters (S3.24 format)
IFeedback	EQU	0.0

	;; SEC3 Constants definitions
;none

	;; SEC4 Memory variables definition
ABS		FbState	0x000

	;; SEC5 Initial values of memory variables
IFbState	EQU	0.0

	;; SEC6 Initialization : (should restore register to 0x0)
CM	0x40000 	INIT
SKIP	!Z		EndInit
C		IFeedback			; load IFeedback
SCA 	0x0  	Feedback	; save to Feedback
C		IFbState			; load IFbState
SCA 	0x0  	FbState		; save to FbState
C       0x1000000     ; 1->A
SCA     0x0     INIT        ; do not reinitialize next time
EndInit:

	;; SEC7 Main
;;; Getting the feedback and adding it to the input
1MC	    0.0		FbState				; A = FbState
AMC		0.0		Feedback			; A = FbState * Feedback
CMA		1.0		IN1					; A = InputSample + FbState * Feedback		
SCA		0.0		OUT1				; Out1 = InputSample + FbState * Feedback

