;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Effect Name : Feedback - part2
;
; Description : Setting value to the feedback path
;
; Nb In       :	1
; Nb Out      : 0
;
; Input       : 1 channel signal
; Output      : none
;
; Cycles      : 2 + 6 cycles (-1=unknownw)
; Memory      : 1 words (without init)
; Delay Line  :	no
;
; Author      : Lall
; Date        : 02/03/2003
; Version     : 1.0
;
; Control parameters (see SEC1): 
;	none
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;; SEC0 General Parameters
ABS	INIT		0x3ff		; init params at first run

	;; SEC1 Control Parameters
;none

	;; SEC2 Initial values of control parameters (S3.24 format)
;none

	;; SEC3 Constants definitions
;none

	;; SEC4 Memory variables definition
ABS		FbState	0x000
;; map this variable onto the FbState of the Feedback_part1.asm module.

	;; SEC5 Initial values of memory variables
IFbState	EQU	0.0

	;; SEC6 Initialization : (should restore register to 0x0)
CM	0x40000 	INIT
SKIP	!Z		EndInit
C		IFbState			; load IFbState
SCA 	0x0  	FbState		; save to FbState
C       0x1000000    ; 1->A
SCA     0x0     INIT        ; do not reinitialize next time
EndInit:

	;; SEC7 Main
;;; Getting the feedback and adding it to the input
1MC		0.0		IN1	   		; A = IN1
SCA		1.0		FbState		; Update the feedback path with the new input

