#include "map.h"
#include "../asm/base/asmfunc.h" // contain ExtractHexa function
#include "messages.h"
#include "properties.h"
#include "extract.h"
#include <string.h>
#include <stdio.h>

int GenerateMemoryMap(char *ProjectFile, CCodeModule **Mods, int NbMods){
  int i,j,offset;
  char name[255];
  FILE *flux, *mapflux;
  UINT32 Map[1024];
  UINT32 val;
  TMemoryMap *p;
  TMemoryMap *tmp;
  TProperty *extra_prop;

  // write map
  strcpy(name, ProjectFile);
  j = strlen(ProjectFile);
  name[j-3] = 'm';
  name[j-2] = 'a';
  name[j-1] = 'p';
  mapflux = fopen(name, "w+");

  // initialize memory map to 0
  for (i=0;i<1024;i++) Map[i]=0;

  // catch definitions in each module.
  // note that most of the work is done when building properties
  // we just need to convert strings to numerical values.
  for (i=0;i<NbMods;i++){
    if ((strcmp(Mods[i]->Name, "IN")==0) || (strcmp(Mods[i]->Name, "OUT")==0)){
      VERBOSE("Skipping IN & OUT modules\n");
      continue;
    }
    VERBOSE1("  module %s\n", Mods[i]->Name);
    p = NULL;

    offset = Mods[i]->GetMemOffset();
    sprintf(name, "%s", Mods[i]->Name);
    if ((flux=fopen(name, "r"))==NULL) return 1;
    if (GetPropertyArray(flux, Mods[i]->SectionsOffset, &p)!=0)
      return 1;
    fclose(flux);

    while(p!=NULL){
      tmp = p;
      // if the propertie was specified in the project,
      // perform the replacement.
      extra_prop=Mods[i]->Prop;
      while (extra_prop!=NULL){
	if (extra_prop->Index-1==tmp->Addr)
	  if (ExtractHexa(extra_prop->Value, &val, 24)==0){
	    tmp->Value = val;
	  }
	extra_prop=extra_prop->next;
      };

      // write map entry
      fprintf(mapflux, "%c %s\t%d\t%d\n", (tmp->type==PROP_TYPE_PARAMETER ? 'P' : 'E'), tmp->Name, tmp->Addr+offset, tmp->Value);
      p=p->next;
      delete tmp;
    };
  }

  fclose(mapflux);
  return 0;
}
