#if !defined( ONEKSIM_TYPES_INCLUDE )
#define ONEKSIM_TYPES_INCLUDE

#ifdef WIN32

#define INT64  __int64
#define INT32  __int32
#define INT16  __int16
#define INT8   __int8
#define UINT64 unsigned __int64
#define UINT32 unsigned __int32
#define UINT16 unsigned __int16
#define UINT8  unsigned __int8
#define CHAR   char
#define UCHAR  unsigned char

#else

#define INT64  long long int   // see definition of int64_t in stdint.h
#define INT32  int
#define INT16  short int
#define INT8   signed char
#define UINT64 unsigned long long int
#define UINT32 unsigned int
#define UINT16 unsigned short int
#define CHAR   char
#define UCHAR  unsigned char

#endif

// for 1st implementation via floating-point of the exp and log
#define FLOAT32 float

///////////////////////////////////////////
// Definition of the basic error defines
///////////////////////////////////////////
#define	GEN_BASE_ERR						0x01000000
#define ASM_BASE_ERR						0x02000000
#define	DISASM_BASE_ERR						0x03000000
#define SIM_BASE_ERR						0x04000000
#define	GUI_BASE_ERR						0x05000000
#define FILEIO_BASE_ERR						0x06000000
#define	TOOLS_BASE_ERR						0x07000000
#define CMD_BASE_ERR						0x08000000

#endif
