#ifndef __AL3101_DISASM_H__
#define __AL3101_DISASM_H__

/* Disassembler for AL3101 */

#define DISASM_FILE_NOT_EXISTS  -1
#define DISASM_WRONG_FILENAME   -1   // this is for backward compatibility
#define DISASM_READ_ERROR       -2
#define DISASM_ERRORS           -3

/*
** This function disassemble the code found in the file 'ObjectFileName' if it exist. 
** It fills the structure AL3101_disasm (see def of AL3101_disasm_struct type).
** It return DISASM_FILE_NOT_EXISTS if thy object fiel not exists
**           DISASM_READ_ERROR      if an error occured when reading the object file,
**           DISASM_ERRORS          if errors were encountered during disassembling
**           the number of codes    if disassemble successfully
*/
int Disassemble(char *ObjectFileName, char *DisasmFileName, 
		AL3101_Disasm_struct *AL3101_disasm);


#endif
