// FileIO_DAT.h: interface for the DAT File functions.
//
//////////////////////////////////////////////////////////////////////

#ifndef __AL3101__FILEIO_DAT__H__
#define __AL3101__FILEIO_DAT__H__

#include <stdio.h>							// for the file IO
#include "../../../common/1K_types.h"		// for the simulator types
#include "./../FileIO_Generic.h"			// for the definition of the generic file IO stuff


//////////////////////////////////
// definition of the prototypes
//////////////////////////////////
// init & clean functions
INT32 FileIO_DAT_Init(void **pInst, CHAR *FileName, INT32 Mode, FileIO_SndCfg *cfg, INT32 *LeftSampleMemory, INT32 *RightSampleMemory = NULL);
INT32 FileIO_DAT_Clean(void *pInst);

// "processing" functions
INT32 FileIO_DAT_ReadSample(void *pInst);
INT32 FileIO_DAT_WriteSample(void *pInst);

// file functions
INT32 FileIO_DAT_GetPosition(void *pInstance, INT32 *CurrentPosition);
INT32 FileIO_DAT_GetFileLength(void *pInstance, INT32 *FileSize);

// control functions
INT32 FileIO_DAT_SetLoopingMode(void *pInst, INT32 Looping);

// text functions
void FileIO_DAT_GetLastErrorString(CHAR *str, INT32 LastErrorCode, INT32 MaxNumberOfCharacters);
void FileIO_DAT_GetHelp(CHAR *str, INT32 LineNumber, INT32 MaxNumberOfCharacters);


//////////////////////////////////
// defines DAT error messages
//////////////////////////////////
#define FILEIO_DAT_NOERROR					(FILEIO_DAT_BASE_ERR +  0)


#endif // !defined(__AL3101__FILEIO_DAT__H__)
