// FileIO_DEC_internal.h: internal definitions for the DEC File functions.
//
///////////////////////////////////////////////////////////////////////////

#ifndef __AL3101__FILEIO_DEC__INTERNAL__H__
#define __AL3101__FILEIO_DEC__INTERNAL__H__

#include <stdio.h>							// for the file IO
#include "./../../../common/1K_types.h"	// for the simulator types
#include "./../FileIO_Generic.h"			// for the definition of the generic file IO stuff


typedef struct FILEIO_DEC_STRUCT
{
	INT32	Loop;				// Specifies if a looping has to be done on the file
								//		if 0		=> no looping is done
								//		otherwise	=> looping done
	INT32	Mode;				// Specifies if the file is in read or write mode
								//		if 0		=> read mode
								//		otherwise	=> write mode
	FILE	*file;				// Handle to the file


	INT32	*LeftData;			// Pointer to the left memory
	INT32	*RightData;			// Pointer to the right memory
	
	INT32	SamplingFrequency;	// The sampling frequency of the file

	INT32	CurrentPos;			// Current position
} FileIO_DEC_Struct;


#endif // !defined(__AL3101__FILEIO_DEC__INTERNAL__H__)
