// FileIO_Generic.h: generic definitions for the file IO modules.
//
//////////////////////////////////////////////////////////////////////

#ifndef __AL3101__FILEIO_GENERIC__H__
#define __AL3101__FILEIO_GENERIC__H__


#include "./../../common/1K_types.h"		// for the simulator types


//////////////////////////////////
// the basic defines
//////////////////////////////////
#define	FILEIO_GEN_BASE_ERR					(FILEIO_BASE_ERR + 0x00010000)
#define FILEIO_PCM_BASE_ERR					(FILEIO_BASE_ERR + 0x00020000)
#define	FILEIO_B24_BASE_ERR					(FILEIO_BASE_ERR + 0x00030000)
#define FILEIO_WAV_BASE_ERR					(FILEIO_BASE_ERR + 0x00040000)
#define FILEIO_DAT_BASE_ERR					(FILEIO_BASE_ERR + 0x00050000)
#define FILEIO_DEC_BASE_ERR					(FILEIO_BASE_ERR + 0x00060000)
#define FILEIO_HEX_BASE_ERR					(FILEIO_BASE_ERR + 0x00070000)


//////////////////////////////////
// defines generic error messages
//////////////////////////////////
#define FILEIO_NOERROR						(FILEIO_GEN_BASE_ERR +  0)
#define FILEIO_CANNOT_ALLOCATE_INSTANCE		(FILEIO_GEN_BASE_ERR +  1)
#define FILEIO_TYPE_NOT_SUPPORTED			(FILEIO_GEN_BASE_ERR +  2)
#define FILEIO_CANNOT_OPEN_FILE				(FILEIO_GEN_BASE_ERR +  3)
#define FILEIO_CANNOT_CLOSE_FILE			(FILEIO_GEN_BASE_ERR +  4)
#define FILEIO_WRONG_FILE_MODE				(FILEIO_GEN_BASE_ERR +  5)
#define FILEIO_READ_ERROR					(FILEIO_GEN_BASE_ERR +  6)
#define	FILEIO_WRITE_ERROR					(FILEIO_GEN_BASE_ERR +  7)
#define FILEIO_EOF_REACHED					(FILEIO_GEN_BASE_ERR +  8)
#define FILEIO_CANNOT_GET_POSITION			(FILEIO_GEN_BASE_ERR +  9)
#define FILEIO_PROBLEM_WHILE_SEEKING		(FILEIO_GEN_BASE_ERR + 10)
#define	FILEIO_INSTANCE_NOT_INITIALIZED		(FILEIO_GEN_BASE_ERR + 11)
#define FILEIO_WRONG_CHANNEL_NUMBER			(FILEIO_GEN_BASE_ERR + 12)


//////////////////////////////////
// definition of the structures
//////////////////////////////////
typedef struct FILEIO_SNDCFG_STRUCT
{
	INT32	SamplingFrequency;
	INT32	NumberOfChannels;
	INT32	NumberOfBytesInSample;
} FileIO_SndCfg;

//////////////////////////////////
// definition of the prototypes
//////////////////////////////////
void FileIO_GetLastErrorString(CHAR *str, INT32 LastErrorCode, INT32 MaxNumberOfCharacters);

#endif // !defined(__AL3101__FILEIO_GENERIC__H__)
