/********************************************************************/
/*                                                                  */
/*                        A X O R I S                               */
/*                                                                  */
/*                Alesis AL3101/2 DSP Simulator                     */
/*                                                                  */
/********************************************************************/
/*                                                                  */
/* Origin Date    : June 2001                                       */
/* Project Version: v0.1                                            */
/* FileName       : HelperFunctions.h                               */
/* File Version   : v0.1                                            */
/* Author         : Fabian Duchesne                                 */
/* Last Modif     : September 2001                                  */
/*                                                                  */
/********************************************************************/

#ifndef _1K_HELPER_FUNCTIONS_
#define _1K_HELPER_FUNCTIONS_

// defines for the display types
#define	AL3101_DISPLAY_FLOAT	0
#define	AL3101_DISPLAY_DS324	1
#define	AL3101_DISPLAY_HS324	3
#define	AL3101_DISPLAY_BS324	5
#define	AL3101_DISPLAY_DS318	2
#define	AL3101_DISPLAY_HS318	4
#define	AL3101_DISPLAY_BS318	6

#define REGMEM_SPECIFIER_LIMIT 6
#define REGMEM_SPECIFIER_MAX 13

// String related helper functions
void String_ToLower_String(CHAR *OutputString, CHAR *InputString);
void String_ToUpper_String(CHAR *OutputString, CHAR *InputString);
void InternalValue_To_String(CHAR *OutputString, INT32 ValueToConvert, INT32 DisplayType, INT32 Precision = 7);

// String and Memory/Register related helper functions
void GetRegMemSpecifier(CHAR *TempStr, INT32 *RegMemSpecifier);
INT32 GetAddressStringFromSpecifier(INT32 RegMemSpecifier, CHAR *IdentifierString, INT32 **ItemToDisplay);
INT32 GetAddressStringsFromSpecifier(INT32 RegMemSpecifier, CHAR *IdentifierString, INT32 **ItemToDisplay, INT32 **LastAllowedItem);

#endif /* _1K_HELPER_FUNCTIONS_ */

