/********************************************************************/
/*                                                                  */
/*                        A X O R I S                               */
/*                                                                  */
/*                Alesis AL3101/2 DSP Simulator                     */
/*                                                                  */
/********************************************************************/
/*                                                                  */
/* Origin Date    : June 2001                                       */
/* Project Version: v0.1                                            */
/* FileName       : AL3101_IOs.h                                    */
/* File Version   : v0.1                                            */
/* Author         : Fabian Duchesne                                 */
/* Last Modif     : September 2001                                  */
/*                                                                  */
/********************************************************************/

#if !defined __1K_AL3101_IOS_INCLUDE
#define __1K_AL3101_IOS_INCLUDE

#include "AL3101_Core.h"

/********************************************************************/
/*                I O S   C O D E S    D E F I N E S                */
/********************************************************************/

/********* I N P U T *********/
#define IN_FILE             0
#define IN_GENERATOR        1
#define IN_LINE             2

/******* O U T P U T *********/
#define OUT_FILE          100  
#define OUT_LINE          101


/********************************************************************/
/*                 I O s  S T R U C T U R E S                       */
/********************************************************************/
typedef struct _IOMode_
{
    const CHAR* name;
    INT32 length;
	INT32 ID;
    INT32 (*Init)(AL3101*, CHAR*, IOTable*, INT32*);
    const CHAR* help;

} AL3101IoMode;

/***** P A R A M E T E R S   S T R U C T U R E S  *****/
typedef struct _File_
{
	CHAR FileName[256];
	FILE* Handle;
	
} FileStruct; 



/********************************************************************/
/*         I O S    F U N C T I O N S    P R O T O T Y P E S        */
/********************************************************************/

/***** I N P U T   F U N C T I O N S *****/
INT32 InFile_Init(AL3101*, CHAR*, IOTable *InputInstance, INT32 *InputInstanceIndex);
INT32 InGen_Init(AL3101*, CHAR*, IOTable *InputInstance, INT32 *InputInstanceIndex);
INT32 InWaveDev_Init(AL3101*, CHAR*, IOTable *InputInstance, INT32 *InputInstanceIndex);

/***** O U T P U T   F U N C T I O N S *****/
INT32 OutFile_Init(AL3101*, CHAR*, IOTable *OutputInstance, INT32 *OutputInstanceIndex);
INT32 OutWaveDev_Init(AL3101*, CHAR*, IOTable *OutputInstance, INT32 *OutputInstanceIndex);

/***** T O O L S   F U N C T I O N S *****/
INT32 Tool_Init(AL3101*, CHAR*);


#endif /* __1K_AL3101_IOS_INCLUDE */

